function KF_cholesky_update(v,R,H,Gv)
%function KF_cholesky_update(v,R,H,Gv)
%
% Calculate the KF (or EKF) update given the prior state [x,P]
% the innovation [v,R] and the (linearised) observation model H.
% The result is calculated using Cholesky factorisation, which
% is more numerically stable than a naive implementation.
%
% Tim Bailey 2003
% Adapted from code by Jose Guivant 
global XX PX
    gama=1.15;% good value old value 1.01
%   [rox cox]=size(PX(1:3,1:3))
    [rox cox]=size(PX);
    L=eye(rox); 
%   RHL=[H;L]*PX(1:3,1:3)*[H' L']
    RHL=[H;L]*PX*[H' L'];
    [rohl cohl]=size(RHL);
    roh=rohl-rox;
    ip=eye(roh); iq=L;
    padz=zeros(roh,cox);
    Riz=[ip padz;padz' -(gama^2)*iq];
    Re=Riz+RHL;
    HL=[H' L'];
    HL3=HL(1:3,:);
%   px=Gv*PX*[H' L']*inv(Re)*[H;L]*PX*Gv'
%   PX=PX-px
    PX(1:3,1:3)=PX(1:3,1:3)-Gv*PX(1:3,1:3)*HL3*inv(Re)*HL3'*PX(1:3,1:3)*Gv';
%    if size(PX,1)>3
%       PX(1:3,4:end)= Gv*PX(1:3,4:end);
%       PX(4:end,1:3)= PX(1:3,4:end)';
%    end   
% Matlab is column-major, so (H*PX)' is more efficient than PX*H' [Tim 2004]
PHt=(H*PX)';
S=H*PHt;
[rs cs]=size(S);
S=S + eye(rs);
%S=(S+S')/2; % ensure is symmetric
%SChol=chol(S);
%SCholInv= inv(SChol); % triangular matrix
%W1= PHt * SCholInv;
%W= W1 * SCholInv';
Kgain=PX*H'*inv(S);
XX= XX + Kgain*v; % update 
% PX= PX - W1*W1';
